'use strict';

var _require = require('jade');

var render = _require.render;

var _require2 = require('babel-core');

var transform = _require2.transform;


module.exports = function () {
  return {
    visitor: {
      TaggedTemplateExpression: function TaggedTemplateExpression(path, state) {
        if (path.node.tag.name === 'jade') {
          (function () {
            var raw = path.node.quasi.quasis[0].value.raw;

            var splitedRaw = raw.split('\n').filter(function (str) {
              return str !== '';
            });
            var rootIndent = /^\s*/.exec(splitedRaw[0])[0];
            var fixedRaw = splitedRaw.map(function (raw) {
              var spaceRegExp = new RegExp('^' + rootIndent);
              return raw.replace(spaceRegExp, '');
            }).join('\n');
            var html = render(fixedRaw).replace(/"\{/g, '{').replace(/\}"/g, '}').replace(/class="/g, 'className="').replace(/for="/g, 'htmlFor="');

            var _transform = transform(html, {
              presets: ['react']
            });

            var code = _transform.code;

            path.replaceWithSourceString(code.replace(/;/g, ''));
          })();
        }
      }
    }
  };
};